<template>
	<v-container class="contenedor" >

		<v-snackbar v-model="snackbar.show" left  :color="snackbarColor" timeout="7000" @click="snackbar.show=false">
			<v-icon  class="pb-1 pr-1">{{snackbarIcon}}</v-icon>
			{{ snackbar.text }}
				<template v-slot:action="{ attrs }">
				<v-btn
					icon
					v-bind="attrs"
					@click="snackbar.show = false"
				>
					<v-icon>close</v-icon>
				</v-btn>
				</template>
		</v-snackbar>

		<v-layout row wrap align-start justify-start flat>
			<v-flex xs12 sm6 md4 xl3 v-for="entorno in enviromentActive" :key="entorno.Nombre" >
					<v-skeleton-loader
							v-if="loading"
							class=" pa-2 ma-3 elevation-2"
							type="article, actions"
					></v-skeleton-loader>
				<v-card
          v-else
					class=" pa-2 ma-3"
					:loading="loading"
					shaped
					>
					<v-card-title>
						<div>{{entorno.Nombre}}</div>
						<v-tooltip top>
							<template v-slot:activator="{on}">
								<v-icon v-on="on" small class="ml-2" :color="entorno.Status=='running' ? 'success' : 'error'">fiber_manual_record</v-icon>
							</template>
							<span>Agregar Hora</span>
						</v-tooltip>
					</v-card-title>
					<v-card-text   style="height:88px">
					<div v-if="entorno.Contenedores[0].State=='running'">
						<v-layout>
							<v-flex shrink class="subtitle-1 font-weight-medium text--darken-2 grey--text" >
							{{entorno.Contenedores[0].Servicio}} 
							</v-flex>
							<v-tooltip top>
									<template v-slot:activator="{on}">
											<v-icon v-on="on" small class="ml-2" :color="entorno.Contenedores[0].State=='running' ? 'success' : 'error'">fiber_manual_record</v-icon>
									</template>
									<span>Estado: {{entorno.Contenedores[0].Status}}</span>
							</v-tooltip>
							<!-- <v-tooltip top>
								<template v-slot:activator="{on}">
										<v-btn icon v-on="on" small>
												<v-icon color="warning" small>autorenew</v-icon>
										</v-btn>
								</template>
								<span>Reiniciar contenedor</span>
							</v-tooltip> -->
						</v-layout>
						<div v-for="puerto in entorno.Contenedores[0].Puertos" :key="puerto.nombre" >
							<div v-if="puerto.PublicPort" :key="`${puerto.IP}-${puerto.PublicPort}`">
								<a v-if="puerto.IP != '0.0.0.0'" target="_blank"
										:href="`https://${puerto.IP}:${puerto.PublicPort}`"
								>https://{{puerto.IP}}:{{puerto.PublicPort}} &rarr; {{puerto.PrivatePort}}</a>
								<div v-else >{{puerto.IP}}:{{puerto.PublicPort}}</div>
							</div>
						</div>
					</div>

					</v-card-text>

					<v-divider></v-divider>

					<v-card-actions>
						<v-tooltip bottom>
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on" @click="restart(entorno)">
											<v-icon color="grey">autorenew</v-icon>
									</v-btn>
							</template>
							<span>Reiniciar</span>
						</v-tooltip>
						<v-tooltip bottom>
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on" @click="el(entorno)">
											<v-icon color="grey">delete</v-icon>
									</v-btn>
							</template>
							<span>Eliminar</span>
						</v-tooltip>
						<v-tooltip bottom v-if="entorno.Status=='running'">
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on" @click="stop(entorno)">
											<v-icon color="grey">stop</v-icon>
									</v-btn>
							</template>
							<span>Detener</span>
						</v-tooltip>
						<v-tooltip bottom v-else>
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on" @click="start(entorno)">
											<v-icon color="grey">play_arrow</v-icon>
									</v-btn>
							</template>
							<span>Iniciar</span>
						</v-tooltip>
						<!-- <v-tooltip bottom>
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on">
											<v-icon color="grey">share</v-icon>
									</v-btn>
							</template>
							<span>Compartir</span>
						</v-tooltip> -->
						<v-spacer></v-spacer>

						<v-btn
							text
							class="text-none grey--text"
							v-if="entorno.Contenedores.length >= 2"
							@click="entornoExpandido = entornoExpandido==entorno.Nombre ? '' : entorno.Nombre"
							>
						Ver más
								<v-icon>{{ entornoExpandido==entorno.Nombre ? 'mdi-chevron-up' : 'mdi-chevron-down' }}</v-icon>
						</v-btn>

					</v-card-actions>

					<v-expand-transition>
						<div v-show="entornoExpandido==entorno.Nombre">
							<v-divider></v-divider>
							
							<v-card-text v-for="(contenedor, i) in entorno.Contenedores" :key="contenedor.Nombre">
								<div v-if="i>1">
									<v-layout>
										<v-flex shrink class="subtitle-1 font-weight-medium text--darken-2 grey--text" >
										{{contenedor.Servicio}}
										</v-flex>
										<v-tooltip top>
												<template v-slot:activator="{on}">
														<v-icon v-on="on" small class="ml-2" :color="contenedor.State=='running' ? 'success' : 'error'">fiber_manual_record</v-icon>
												</template>
												<span>Estado: {{contenedor.Status}}</span>
										</v-tooltip>
										<v-tooltip top>
											<template v-slot:activator="{on}">
													<v-btn icon v-on="on" small @click="restart(entorno)">
															<v-icon color="warning" small>autorenew</v-icon>
													</v-btn>
											</template>
											<span>Reiniciar contenedor</span>
										</v-tooltip>
									</v-layout>
									<div v-for="puerto in contenedor.Puertos" :key="puerto.nombre" >
										<div v-if="puerto.PublicPort" :key="`${puerto.IP}-${puerto.PublicPort}`">
											<a v-if="puerto.IP != '0.0.0.0'" target="_blank"
													:href="`https://${puerto.IP}:${puerto.PublicPort}`"
											>https://{{puerto.IP}}:{{puerto.PublicPort}}</a>
											<div v-else >{{puerto.IP}}:{{puerto.PublicPort}}</div>
										</div>
									</div>
							</div>
							</v-card-text>
						</div>
					</v-expand-transition>
				</v-card>
			</v-flex>
			
			<v-flex xs12 sm6 md4 lg3 v-for="entorno in enviromentDisabled" :key="entorno.nombre">
				<v-skeleton-loader
					v-if="loading"
					class=" pa-2 ma-3 elevation-2"
					type="article, actions"
				></v-skeleton-loader>
				<v-card v-if="entorno.Status!='running' && !loading"
				class=" pa-2 ma-3"
				:loading="loading"
				shaped
				>
					<v-card-title>
						<div>{{entorno.Nombre}}</div>
						<v-tooltip top>
							<template v-slot:activator="{on}">
								<v-icon v-on="on" small class="ml-2" :color="entorno.Status=='running' ? 'success' : 'error'">fiber_manual_record</v-icon>
							</template>
							<span>Agregar Hora</span>
						</v-tooltip>
					</v-card-title>


					<v-card-text  style="height:88px">
					<div v-if="entorno.Contenedores.State=='running'">
						<v-layout>
							<v-flex shrink class="subtitle-1 font-weight-medium text--darken-2 grey--text" >
							{{entorno.Contenedores.Servicio}} iiiiiii
							</v-flex>
							<v-tooltip top>
									<template v-slot:activator="{on}">
											<v-icon v-on="on" small class="ml-2" :color="entorno.Contenedores.State=='running' ? 'success' : 'error'">fiber_manual_record</v-icon>
									</template>
									<span>Estado: {{entorno.Contenedores.Status}}</span>
							</v-tooltip>
						</v-layout>
						<div v-for="puerto in entorno.Contenedores.Puertos" :key="puerto.nombre" >
							<div v-if="puerto.PublicPort" :key="`${puerto.IP}-${puerto.PublicPort}`">
								<a v-if="puerto.IP != '0.0.0.0'" target="_blank"
										:href="`https://${puerto.IP}:${puerto.PublicPort}`"
								>https://{{puerto.IP}}:{{puerto.PublicPort}}</a>
								<div v-else >{{puerto.IP}}:{{puerto.PublicPort}}</div>
							</div>
						</div>
					</div>
					<div v-else style="height:100%;align-items:center;display:flex;font-style:italic">
						No hay contenedores activos
					</div>
					</v-card-text>

					<v-divider></v-divider>

					<v-card-actions>
						<v-tooltip bottom>
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on" @click="restart(entorno)">
											<v-icon color="grey">autorenew</v-icon>
									</v-btn>
							</template>
							<span>Reiniciar</span>
						</v-tooltip>
						<v-tooltip bottom>
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on" @click="el(entorno)">
											<v-icon color="grey">delete</v-icon>
									</v-btn>
							</template>
							<span>Eliminar</span>
						</v-tooltip>
						<v-tooltip bottom v-if="entorno.Status=='running'">
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on" @click="stop(entorno)">
											<v-icon color="grey">stop</v-icon>
									</v-btn>
							</template>
							<span>Detener</span>
						</v-tooltip>
						<v-tooltip bottom v-else>
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on" @click="start(entorno)">
											<v-icon color="grey">play_arrow</v-icon>
									</v-btn>
							</template>
							<span>Iniciar</span>
						</v-tooltip>
						<!-- <v-tooltip bottom>
							<template v-slot:activator="{on}">
									<v-btn icon v-on="on">
											<v-icon color="grey">share</v-icon>
									</v-btn>
							</template>
							<span>Compartir</span>
						</v-tooltip> -->
						<v-spacer></v-spacer>

						<v-btn
							text
							class="text-none grey--text"
							v-if="entorno.Contenedores.length >= 1"
							@click="entornoExpandido = entornoExpandido==entorno.Nombre ? '' : entorno.Nombre"
							>
						Ver más
								<v-icon>{{ entornoExpandido==entorno.Nombre ? 'mdi-chevron-up' : 'mdi-chevron-down' }}</v-icon>
						</v-btn>
					</v-card-actions>

					<v-expand-transition>
						<div v-show="entornoExpandido==entorno.Nombre">
							<v-divider></v-divider>
							
							<v-card-text v-for="(contenedor) in entorno.Contenedores" :key="contenedor.Nombre">
								<div >
									<v-layout>
										<v-flex shrink class="subtitle-1 font-weight-medium text--darken-2 grey--text" >
										{{contenedor.Servicio}}
										</v-flex>
										<v-tooltip top>
												<template v-slot:activator="{on}">
														<v-icon v-on="on" small class="ml-2" :color="contenedor.State=='running' ? 'success' : 'error'">fiber_manual_record</v-icon>
												</template>
												<span>Estado: {{contenedor.Status}}</span>
										</v-tooltip>
									</v-layout>
									<div v-for="puerto in contenedor.Puertos" :key="puerto.nombre" >
										<div v-if="puerto.PublicPort" :key="`${puerto.IP}-${puerto.PublicPort}`">
											<a v-if="puerto.IP != '0.0.0.0'" target="_blank"
													:href="`https://${puerto.IP}:${puerto.PublicPort}`"
											>https://{{puerto.IP}}:{{puerto.PublicPort}}</a>
											<div v-else >{{puerto.IP}}:{{puerto.PublicPort}}</div>
										</div>
									</div>
								</div>
							</v-card-text>
						</div>
					</v-expand-transition>
				</v-card>
			</v-flex>
		</v-layout>

		<div style="height:58px;position: relative">

				<v-btn
					color="primary"
					dark
					bottom
					right
					fab
					style="right:10px;bottom:25px;position:fixed"
					@click="dialogCrear"
				>
					<v-icon>mdi-plus</v-icon>
				</v-btn>

		</div>



		<!-- Dialog nuevo entorno -->
		<v-dialog
			v-model="dialog"
			width="500"
      @click:outside="cerrarBoton()"
		>
			<v-card >
				<v-card-title>Nuevo entorno</v-card-title>
				<v-card-text>
					<v-row justify="center">
						<v-col
							cols="12"
							>
							<v-form v-model="valid" lazy-validation ref="form">
								<v-text-field
									:rules="[REGLAS.sinEspacios, REGLAS.requerido]"
									v-model="dataNombre"
									label="Nombre del entorno"
									:error="entornoError"
									:messages="mensajeError"
									required
								></v-text-field>
								<v-autocomplete
									menu-props="auto, overflowY"
									:rules="[REGLAS.requerido]"
									v-model="dataTemplete"
									:items="plantillas"
									label="Plantilla"
									required
								></v-autocomplete>
							</v-form>
							
						</v-col>
					</v-row>
				</v-card-text>
				<v-divider></v-divider>
				<v-card-actions>
					<v-spacer></v-spacer>
					<v-btn
						color="grey"
						text
						@click="cerrarBoton()"
					>
						Volver
					</v-btn>
					<v-btn
						:disabled="!valid"
						color="primary"
						text
						@click="onCreate()"
					>
						Aceptar
					</v-btn>
				</v-card-actions>
			</v-card>
		</v-dialog>

		<!-- Dialog confirmacion para eliminar -->
		<v-dialog
			v-model="dialogEliminar"
			width="400"
		>
			<v-card>
				<v-card-title>¿Está seguro de que quiere eliminar?</v-card-title>
				<v-card-text>
					<v-row>
						<v-col
							cols="12"
							>
						Al eliminar no podrá recuperarlo
						</v-col>
					</v-row>
				</v-card-text>
				<v-divider></v-divider>
				<v-card-actions>
					<v-spacer></v-spacer>
					<v-btn
						color="grey"
						text
						@click="dialogEliminar=false"
					>
						Volver
					</v-btn>
					<v-btn
						color="error"
						text
						@click="onDelete(entornoAEliminar)"
					>
						Eliminar
					</v-btn>
				</v-card-actions>
			</v-card>
		</v-dialog>

	</v-container>
</template>
<script>
export default {
	async mounted(){
		await this.fetchEntornos()
        await this.fetchPlantillas()
	},
	computed: {


		snackbarIcon(){
			if(this.snackbar.create){
				return "check_circle"
			}else if(this.snackbar.delete){
				return 'delete'
			}else if(this.snackbar.error){
				return 'error'
			}else{
				return 'done'
			}
			
		},
		
		snackbarColor(){
			if(this.snackbar.create){
				return 'success'
			}else if(this.snackbar.delete){
				return 'success'
			}else if(this.snackbar.error){
				return 'error'
			}else{
				return 'success'
			}
			
		},

		mensajeError(){
			if(this.entornoError){
				return 'Ese nombre ya existe'
			}
			return ''
		},

		enviromentActive(){
			let ret = [];
			if(this.entornos==null){
				return ret
			}
			ret = this.entornos.filter(entorno => entorno.Status=='running');
			for(let e of ret){
				e.Contenedores[0].Puertos.sort((a,b)=>{
					if(b.PrivatePort > a.PrivatePort){
						return -1
					}
					if (a.PrivatePort > b.PrivatePort) {
						return 1
					}
					return 0
				})
			}

			ret.sort((a,b)=>{
				if(b.Nombre > a.Nombre){
					return -1
				}
				if (a.Nombre > b.Nombre) {
					return 1
				}
				return 0
			})
			return ret;
		},


		enviromentDisabled(){
			let ret = [];
			if(this.entornos==null){
				return ret
			}
			ret = this.entornos.filter(entorno => entorno.Status!='running');
			return ret;
		}

	},


	methods:{

		el(entorno){
			this.entornoAEliminar = entorno.Nombre
			this.dialogEliminar = true
		},
		fetchEntornos() {
			this.loading = true
			fetch('/api/entornos')
			.then(response => response.json())
			.then(data => {
				this.entornos = data
				this.loading = false
			});
        },
		fetchPlantillas() {
			this.loading = true
			fetch('/api/plantillas')
			.then(response => response.json())
			.then(data => {
				this.plantillas = data
				this.loading = false
			});
		},

		onDelete(entornoAEliminar){
			if(entornoAEliminar) {
				this.loading = true
				fetch(`/api/entornos/${entornoAEliminar}`, {
					method: 'DELETE',
				})
				// .then(response => response.json())
				.then(async (response) => {
					if(response.ok){
					this.fetchEntornos()
					this.snackbar = {
							text: 'Entorno eliminado',
							show: true,
							delete:true,
					}
					}else{
						let texto = await response.text()
						throw new Error(texto)
						
					}
				})
				
				.catch((error) => {
						this.snackbar = {
							text: error,
							show: true,
							error:true,
					}

				})
				.finally(() => {
					this.fetchEntornos()
					this.loading=false

				})
				
			}
			// this.entornoAEliminar = null
			this.dialogEliminar = false
		},
        
		cerrarBoton(){
			this.dialog=false
			this.dataNombre=''
			this.dataTemplete=''
			this.entornoError=false
		},

		dialogCrear(){
			this.dialog=true
		},

		onCreate(){
			this.$refs.form.validate()
			let data = {}
			data.nombre = this.dataNombre
			data.template = this.dataTemplete

			for (const index in this.enviromentActive) {
				const element = this.enviromentActive[index];
				if(element.Nombre == data.nombre){
					return this.entornoError = true
				}
			}

			if(data.nombre && data.template ) {
				this.loading = true
				fetch(`/api/entornos/`, {
					method: 'POST',
					body: JSON.stringify(data)
				})
				.then(async (response) => {
					if(response.ok){
					this.fetchEntornos()
					this.snackbar = {
							text: 'Entorno creado con éxito',
							show: true,
							create:true,
					}
					}else{
						let texto = await response.text()
						throw new Error(texto)
						
					}
				})				
				.catch((error) => {
						this.snackbar = {
							text: error,
							show: true,
							error:true,
					}
				})
				.finally(() => {
					this.fetchEntornos()
					this.loading=false
				})
			}
			
			this.dialog = false
			this.dataNombre=''
			this.dataTemplete=''
			this.$refs.form.reset()
		},
		stop(entorno) {
			entorno = entorno ? entorno.Nombre : ''
			if(entorno) {
				this.loading = true
				fetch(`/api/entornos/${entorno}/stop`, {
					method: 'PUT',
				})
				.then(async (response) => {
					if(response.ok){
					this.fetchEntornos()
					this.snackbar = {
							text: 'Entorno detenico',
							show: true,
							delete:true,
					}
					}else{
						let texto = await response.text()
						throw new Error(texto)
						
					}
				})
				.catch((error) => {
						this.snackbar = {
							text: error,
							show: true,
							error:true,
					}

				})
				.finally(() => {
					this.fetchEntornos()
					this.loading=false

				})
				
			}
		},
		start(entorno) {
			entorno = entorno ? entorno.Nombre : ''
			if(entorno) {
				this.loading = true
				fetch(`/api/entornos/${entorno}/start`, {
					method: 'PUT',
				})
				.then(async (response) => {
					if(response.ok){
					this.fetchEntornos()
					this.snackbar = {
							text: 'Entorno Iniciado',
							show: true,
							delete:true,
					}
					}else{
						let texto = await response.text()
						throw new Error(texto)
						
					}
				})
				.catch((error) => {
						this.snackbar = {
							text: error,
							show: true,
							error:true,
					}

				})
				.finally(() => {
					this.fetchEntornos()
					this.loading=false

				})
				
			}
		},
		restart(entorno) {
			entorno = entorno ? entorno.Nombre : ''
			if(entorno) {
				this.loading = true
				fetch(`/api/entornos/${entorno}/restart`, {
					method: 'PUT',
				})
				.then(async (response) => {
					if(response.ok){
					this.fetchEntornos()
					this.snackbar = {
							text: 'Reiniciando Iniciado',
							show: true,
							delete:true,
					}
					}else{
						let texto = await response.text()
						throw new Error(texto)
						
					}
				})
				.catch((error) => {
						this.snackbar = {
							text: error,
							show: true,
							error:true,
					}

				})
				.finally(() => {
					this.fetchEntornos()
					this.loading=false

				})
				
			}
		}
	},
	data(){
		return {
			msg: 'Debe proporcionar un nombre unico al entorno',
			entornoError: false,
			entornoAEliminar: null,
			entornos: null,
			loading: true,
			dialog: false,
			dialogEliminar: false,
			show: false,
			activo:true,
			dataNombre: '',
			dataTemplete: '',
			plantillas:null,
			entornoExpandido:null,
			valid: false,
			snackbar: {
				show: false,
				text: '',
				delete:false,
				create:false,
				error:false,
			},
			REGLAS: {
				sinEspacios: (v) => !v || !!/^[^ ]*$/.test(v) || "El campo no puede contener espacios",
				requerido: (v) => !!v || "Debe completar este campo",
			}
		}
	}
}

</script>

<style>
	.scroll {
	overflow-y: scroll
	}
</style>

<style lang="scss" scoped>
@import "../scss/breakpoints.scss";

::v-deep .v-skeleton-loader__button{
    border-radius:50px !important;
    height: 36px !important;
    width: 36px !important;

}

::v-deep .v-skeleton-loader__actions{
    text-align:left;
} 

.contenedor{
	max-width:100%;
	@include xs{
		margin-left:20px;
		margin-right:20px;
	}
	@include sm{
		margin-left:5%;
		margin-right:5%;
	}
	@include md{
		margin-left:50px;
		margin-right:50px;
	}
		@include lg{
		margin-left:5%;
		margin-right:5%;
	}
}
</style>